<template>
	<v-row class="search-box" align="center" no-gutters>
		<v-col :cols="option.labelCols">
			<label for="" class="search-box-label">
				<v-icon
					x-small
					:color="item.required ? '#fb8200' : 'primary'"
					class="mr-1"
					>mdi-record-circle</v-icon
				>
				{{ option.labelContent }}
			</label>
		</v-col>
		<v-col :cols="option.textCols">
			<v-text-field
				readonly
				v-model="selectValue"
				append-icon="mdi-magnify"
				class="v-input__custom"
				@click="dialogOpenCloseEvent(dialog)"
				outlined
				:hide-details="true"
				:required="item.required || false"
				:disabled="item.disabled || false"
			></v-text-field>
		</v-col>

		<v-dialog v-model="dialog" scrollable width="540px">
			<v-card style="height: 100%">
				<v-card-title class="pa-5 d-flex align-center justify-space-between">
					<span class="custom-title-4">{{ option.modalTitle }}</span>
					<v-btn
						icon
						tile
						:ripple="false"
						@click="dialogOpenCloseEvent(dialog)"
					>
						<v-icon>mdi-close</v-icon>
					</v-btn>
				</v-card-title>
				<div class="pa-5">
					<v-row align="center" no-gutters>
						<v-col :cols="2">
							<label for="" class="search-box-label">
								<v-icon x-small color="primary" class="mr-1"
									>mdi-record-circle</v-icon
								>
								검색
							</label>
						</v-col>
						<v-col :cols="6">
							<v-text-field
								append-icon="mdi-magnify"
								class="v-input__custom"
								outlined
								:hide-details="true"
								v-model="searchWord"
								placeholder="배치명을 입력하세요."
								@keyup.enter="search"
							></v-text-field>
						</v-col>
						<v-spacer></v-spacer>
						<v-col cols="4" class="text-right">
							<v-btn :ripple="false" @click="search()">
								조회
							</v-btn>
							<!-- <v-btn :ripple="false" @click="initSearch()">
                초기화
              </v-btn> -->
						</v-col>
					</v-row>
				</div>
				<v-divider></v-divider>
				<div :style="'height: calc(50vh)'">
					<!-- <div :style="{ height: 'calc(100% - 213px)' }"> -->
					<div ref="modalGridParent" class="h100 py-3">
						<component
							:is="loadGrid && dialog ? 'Grid' : null"
							:gridName="grid_01"
							:dataPath="searchParam.modalData2.evtObjPop"
							:parentPrgmId="parentPrgmId"
							@getRowsData="getRowData"
							@dblClick="setUpdate($event)"
						/>
					</div>
				</div>
				<v-card-actions class="pa-5 d-flex align-center justify-center">
					<v-btn :ripple="false" @click="setUpdate($event)">확인</v-btn>
					<v-btn :ripple="false" @click="dialogOpenCloseEvent(dialog)"
						>닫기</v-btn
					>
				</v-card-actions>
			</v-card>
		</v-dialog>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
import Grid from '~/components/common/Grid';
import Utility from '~/plugins/utility';

export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
		labelContent: {
			type: String,
			require: false,
			default: '이벤트항목',
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		modalTitle: {
			type: String,
			require: false,
			default: '이벤트항목',
		},
		modalContent: {
			type: String,
			require: false,
			default: '검색',
		},
		item: {
			type: Object,
			require: false,
		},
		bindingData: {
			type: String,
			require: false,
		},
		// bindingFlag:{
		//   type:Boolean,
		//   require: false,
		//   default: false
		// }
	},
	components: {
		Grid,
		Utility,
	},
	data() {
		return {
			dialog: false,

			loadGrid: false,
			grid_01: 'grid_01',
			myModalKey: 'evtObjPop',
			modalDataKey: 'modalData2',

			searchWord: '',
			selectedData: {},
			textFieldData: '',

			option: {
				labelCols:
					this.item !== undefined
						? this.item.labelCols !== undefined
							? this.item.labelCols
							: this.labelCols
						: this.labelCols,
				labelContent:
					this.item !== undefined
						? this.item.labelContent !== undefined
							? this.item.labelContent
							: this.labelContent
						: this.labelContent,
				textCols:
					this.item !== undefined
						? this.item.textCols !== undefined
							? this.item.textCols
							: this.textCols
						: this.textCols,
				modalTitle:
					this.item !== undefined
						? this.item.modalTitle !== undefined
							? this.item.modalTitle
							: this.modalTitle
						: this.modalTitle,
			},
		};
	},
	computed: {
		...mapState({
			searchParam(state) {
				return state.pageData[this.parentPrgmId];
			},
			myBindingData(state) {
				if (!this.bindingData) {
					return state.pageData[this.parentPrgmId]['rowGridSelectData'];
				} else {
					return state.pageData[this.parentPrgmId][this.bindingData][
						'rowGridSelectData'
					];
				}
			},
		}),
		selectValue: {
			get() {
				if (!this.item) {
					return this.textFieldData;
				}
				// else if(this.item.disableContent){
				//   return "NONE";
				// }
				else {
					return this.myBindingData
						? this.myBindingData[this.item.valueNm]
						: this.textFieldData;
				}
			},
			set(value) {
				// if(this.item && this.item.disableContent){
				//   return "NONE";
				// }
				return value;
			},
		},
	},
	watch: {
		async dialog(val) {
			if (val) {
				await this.getGridData();
			}
		},
	},

	beforeCreate() {
		this.$store.commit('setPageData', {
			modalData2: { evtObjPop },
		});
	},
	created() {
		this.init();
	},
	mounted() {},
	methods: {
		...mapMutations({
			setPageData: 'setPageData',
			setModalGridData: 'setModalGridData',
			setModalGridColumn: 'setModalGridColumn',
			setModalGridOption: 'setModalGridOption',
		}),
		...mapActions({
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
		}),
		init() {
			this.gridInit();
		},
		search() {
			this.getGridData();
		},
		initSearch() {
			this.searchWord = '';
			this.getGridData();
		},
		gridInit() {
			const myOptions = {
				columnOptions: {
					resizable: true,
				},
			};
			this.setModalGridOption({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: Object.assign(
					// Utility.defaultGridOption(this.$refs.modalGridParent.offsetHeight - 60, myOptions),
					Utility.defaultGridOption(400, myOptions),
					myOptions,
				),
			});

			this.setModalGridColumn({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: [
					{ header: '배치 ID', name: 'batchId', align: 'center', width: 150 },
					{ header: '배치명', name: 'batchNm', align: 'left' },
				],
			});
		},
		async getGridData() {
			this.loadGrid = false;

			const res = await this.postApiReturn({
				apiKey: 'selectBatchMng',
				resKey: 'batchMngData',
				sendParam: {
					useFg: '1',
					batchNm: this.searchWord,
				},
			});

			this.setModalGridData({
				modalKey: this.myModalKey,
				gridKey: this.grid_01,
				modalDataKey: this.modalDataKey,
				value: res,
			});

			this.loadGrid = true;
		},
		getRowData(data) {
			this.selectedData = { ...data };
		},
		setUpdate(v) {
			this.dialog = false;
			if (!this.item) {
				this.textFieldData = this.selectedData.batchId;
			} else {
				if (this.item.bindNm) {
					this.myBindingData[this.item.bindNm] = this.selectedData.batchNm;
				} else {
					this.myBindingData.batchNm = this.selectedData.batchNm;
				}

				const dt = {
					columnName: this.item.valueNm,
					value: this.selectedData.batchId,
				};
				this.$emit('gridEditingFinish', dt);
				if (this.item.valueNm2 !== undefined) {
					const dt = {
						columnName: this.item.valueNm2,
						value: this.selectedData[this.item.valueNm2],
					};
					this.$emit('gridEditingFinish', dt);
				}
				if (this.item.bindNm !== undefined) {
					const dt = {
						columnName: this.item.bindNm,
						value: this.selectedData.batchNm,
					};
					this.$emit('gridEditingFinish', dt);
				}
			}
		},
		dialogOpenCloseEvent(val) {
			// if(this.item && this.item.disableContent){
			//   this.dialog = false;
			//   return;
			// }
			this.dialog = !val;
		},
	},
};

var evtObjPop = {
	grid_01: {
		data: [],
		column: [],
		option: {},
	},
};
</script>

<style lang="scss" scoped>
::v-deep {
	.v-dialog {
		overflow-y: hidden !important;
	}

	.tui-grid-table-container {
		.tui-grid-table {
			border-right-style: solid !important;
			border-right-color: rgba(255, 255, 255, 0.1) !important;
		}
	}

	.tui-grid-cell.tui-grid-cell-has-tree
		.tui-grid-tree-extra-content
		+ .tui-grid-cell-content:before {
		content: none !important;
	}
}

@each $theme in dark, light {
	.v-application.#{$theme}-mode {
		.v-dialog {
			.v-card {
				&__title {
					color: map-deep-get($color, 'white', '0');
					@if $theme == dark {
						background-color: #2d3355;
						.v-btn {
							background-color: #2d3355;
						}
					} @else {
						background-color: #3f4d7d;
						.v-btn {
							background-color: #3f4d7d;
						}
					}
				}
			}
		}
	}
}
</style>
